import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * Write a description of class BossEnemies here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BossEnemies extends Enemies
{
    private Exhaust exhaust; 
    private boolean smart = Settings.MovingEnemies;
    private boolean invincible = false;
    private Bar bar = null;
    private int time = 3; //idk why but this needs to wait a bit before it can die so the shot can register the touch too
    private int health = Settings.BossEnemiesHealth;
    private int timer = 0;
    private int attackLevel = 2; //1: they'll just wander /2: sometimes run away /3: PANIC!!!111!1!
    /*
     * Enemy Settings
     */
    private int MaxHealth = Settings.BossEnemiesHealth;
    
    /**
     * Constructor for objects of class SettingsScreen.
     * i: make the boss invincible
     */
    public BossEnemies(boolean i){
        invincible = i;
        if (i) {
            imageSize(-150);
        }
    }
    /**
     * Act - do whatever BossEnemies wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //Ceck for game over or TitleScreen
        if ( ! getWorld().getObjects(Button.class).isEmpty())  return;
        
        // Follow Spaceship if MovingEnemies is enabled, otherwise don't move
        if (smart) {
            if (isAtEdge()){
                turn(Greenfoot.getRandomNumber(180)+90);
            
            }
            
            Spaceship sp = getWorld().getObjects(Spaceship.class).get(0);
            turnTowards(sp.getX(), sp.getY());
            move(Settings.BossEnemiesSpeed);
            
        }
        if (time > 1) {
            time--;
        }
        if (timer > 0) {
            timer--;
        }
        
        // Shot a shot towards the Spaceship if the Timer is 0 again
        if (timer == 0) {
            timer = Settings.BossShotsTimer;
            int rot = getRotation();
            setRotation(0);
            launchShot(rot, getX(), getY());
        }
        // Set Rotation to 0 to always seem upright
        setRotation(0);
            
        // Update healthbar
        bar = updateHealthBar(bar, MaxHealth, health);
        
        // Check if it has been shot
        ArrayList<Integer> n = touchPlayerShot(time, health, exhaust, bar, Settings.BossEnemiesPoints);
        time = n.get(0);
        health = n.get(1);
    }
}
