"""
Java project code line counter
by Jannis Martensen
"""

import glob

# Get line count of file
def file_len(fname):
    with open(fname) as f:
        for i, l in enumerate(f):
            pass
    return i + 1


lines = 0
f = open("CodeLines.txt", "w")

# Count lines and add to list in list
files = []
for file in glob.glob("*.java"):
    l = file_len(file);
    p = [file, l]
    files.append(p)

    lines += l

# Sort files by line count and print/write them to a text file
files = sorted(files, key=lambda x: x[1], reverse=True)
for i in files:
    print(f"{i[0]}: {i[1]}")
    f.write(f"{i[0]}: {i[1]}\n")

# Total line count
print(f"\nTotal: {lines}")
f.write(f"\nTotal: {lines}")
f.close()
