import java.util.ArrayList;
import java.util.HashMap;

/**
 * Settings: 
 * 
 * READ ME:    
 * READ ME: Don't change this file but instead create a save, edit the values and then load it.
 * READ ME:    
 * 
 * Total of 62 Settings
 *
 * @author Jannis Martensen
 * @version 1.0
 */
public class Settings
{
    // Spaceship Settings
        /** Allows the ship to shoot bullets                                 */  public static boolean    CanShoot                = true;    
        /** Set the delay between shots                                      */  public static int        ShotsDelay              = 100;     
        /** Speed of shots                                                   */  public static double     ShotsSpeed              = 1.8;
        /** Normal flying speed                                              */  public static double     NormalSpeed             = 1.0;   
        /** Boost speed                                                      */  public static double     BoostSpeed              = 1.5;   
        /** The amount of time the ship can boost                            */  public static int        BoostTime               = 500; 
        /** The amount of time the boost recharge should take                */  public static int        BoostRechargeTime       = 1000;    
        /** Allows the ship to boost                                         */  public static boolean    CanBoost                = true;   
        /** Hold shift to continue driving at normal speed and auto-boosts   */  public static boolean    BoostCanDrive           = true;   
        /** Time it takes to accelerate/deccelerate                          */  public static int        AccelerationTime        = 300;       
        /** Allows the ship to move backward by pressing 's'                 */  public static boolean    CanMoveBackward         = false;     

    
    
    // Spaceship Skin Settings
        /** Set the Spaceship color (Black, Blue, Green, Normal, Pink, Purple, White, Yellow)                 */  public static String     SpaceshipColor          = "Black";   
        /** Set the color of the Spaceship exhaust (Green, Pink, Red, Yellow, Orange, Purple, Blue, White)    */  public static String     SpaceshipExhaustColor   = "Blue";    
        /** Set the color of the shots from the spaceship (Green, Pink, Red, Yellow, Orange, Purple)          */  public static String     SpaceshipShotsColor     = "Orange";  

    // Spaceship2 Skin Settings
        /** Set the Spaceship2 color (Black, Blue, Green, Normal, Pink, Purple, White, Yellow)                */  public static String     Spaceship2Color         = "White";   
        /** Set the color of the Spaceship2 exhaust (Green, Pink, Red, Yellow, Orange, Purple, Blue, White)   */  public static String     Spaceship2ExhaustColor  = "Red";    
        /** Set the color of the shots from the spaceship2 (Green, Pink, Red, Yellow, Orange, Purple)         */  public static String     Spaceship2ShotsColor    = "Yellow";  

    
    
    // Enemy/Asteroid Settings
        /** Destroying an asteroid grants a point                */  public static boolean    AsteroidsGrantPoints    = false;     
        /** Destroying an enemy grants a point                   */  public static boolean    EnemiesGrantPoints      = true;      
        /** Show enemy ship exhaust                              */  public static boolean    EnemiesHaveExhausts     = true;      
        /** Show enemy ship health bars                          */  public static boolean    EnemiesShowHealthBar    = true;   
        /** Should the enemys move or not                        */  public static boolean    MovingEnemies           = true;      
        /** Exact Collision(more efficient) or normal collision  */  public static boolean    PixelExactCollision     = true;      
        /** Set the delay between shots of Bosses                */  public static int        BossShotsTimer          = 500;       

    
    
    // Enemy Speed Settings
        /** Scale up speed based on points      */   public static boolean    ScaleEnemiesSpeed       = true;
        /** Max out enemy speed on what points  */   public static int        ScaleSpeedMaxPoints     = 50;
        
        
            // These values will only be used if ScaleEnemiesSpeed is true
            /** Min Speed of the easy enemies      */  public static double     EasyEnemiesMinSpeed     = 0.8; 
            /** Max Speed of the easy enemies      */  public static double     EasyEnemiesMaxSpeed     = 1.2; 
            /** Min Speed of the attacker enemies  */  public static double     AttackerEnemiesMinSpeed = 0.3; 
            /** Max Speed of the attacker enemies  */  public static double     AttackerEnemiesMaxSpeed = 0.6;       
            /** Min Speed of the boss enemies      */  public static double     BossEnemiesMinSpeed     = 0.15;
            /** Max Speed of the boss enemies      */  public static double     BossEnemiesMaxSpeed     = 0.3;     
    
            // These values will only be used if ScaleEnemiesSpeed is false
            /** Speed of the easy enemies          */  public static double     EasyEnemiesSpeed        = 0.8;  
            /** Speed of the attacker enemies      */  public static double     AttackerEnemiesSpeed    = 0.3; 
            /** Speed of the boss enemies          */  public static double     BossEnemiesSpeed        = 0.15;
        
    
    
    // Enemy Score Settings
        /** Points for the easy enemies        */  public static int        EasyEnemiesPoints       = 1;         
        /** Points for the attacker enemies    */  public static int        AttackerEnemiesPoints   = 10;        
        /** Points for the boss enemies        */  public static int        BossEnemiesPoints       = 30;        

    
    
    // Asteroid Score Settings
        /** Points for small asteroids         */  public static int        SmallAsteroidPoints     = 1;         
        /** Points for medium asteroids        */  public static int        MediumAsteroidPoints    = 1;         
        /** Points for big asteroids           */  public static int        BigAsteroidPoints       = 2;         

    
    
    // Health Settings
        /** Health of the ship                 */  public static int        SpaceshipHealth         = 10;        
        /** Health of small asteroids          */  public static int        SmallAsteroidHealth     = 1;                  
        /** Health of medium asteroids         */  public static int        MediumAsteroidHealth    = 3;         
        /** Health of big asteroids            */  public static int        BigAsteroidHealth       = 5;         
        /** Health of the easy enemies         */  public static int        EasyEnemiesHealth       = 1;         
        /** Health of the attacker enemies     */  public static int        AttackerEnemiesHealth   = 25;        
        /** Health of the boss enemies         */  public static int        BossEnemiesHealth       = 50;        

    
    
    // Level Unlock Status
        /** Unlock all levels instantly                     */  public static boolean    UnlockAll               = false;     
    
        /** Unlock status of "Asteroids" Level              */  public static boolean    AsteroidsUnlocked       = true;      
        /** Unlock status of "Followers" Level              */  public static boolean    FollowersUnlocked       = false;     
        /** Unlock statos of "Battle for Earth" Level       */  public static boolean    BattleForEarth          = false;  
        /** Unlock status of "BattleOfTwilightGap" Level    */  public static boolean    BattleOfTwilightGap     = false;  
        /** Unlock status of "Helm's Deep" Level            */  public static boolean    HelmsDeep               = false; 
        /** Unlock status of "BattleOfTheCity" Level        */  public static boolean    BattleOfTheCity         = false;   
        /** Unlock status of "Boss" Level                   */  public static boolean    BossUnlocked            = false;     
        
    
    
    // Other Settings
        /** How many points to unlock the next level                                               */  public static int        LevelUnlockThreshold    = 30;
        /** TwoPlayer Mode                                                                         */  public static boolean    TwoPlayerMode           = false;
        /** en: English, de: Deutsch                                                               */  public static String     Language                = "en";      
        /** Show "Settings" option in the title menu (adjust language button to left if enabled)   */  public static boolean    ShowSettingsOption      = true;      
        /** Show info text above the two choosing sides in the title menu (auto adjust other text) */  public static boolean    ShowChooseText          = false; 
        /** Show playerNames in two player moder                                                   */  public static boolean    ShowPlayerNames         = false;    
    
        /** Scoreboard save  */                              public static HashMap<String, ArrayList<Integer>> ScoreList = new HashMap<String, ArrayList<Integer>>(); 
        
    
    
    private static volatile Settings instance;
    /**
     * Get already existing instance of class
     */
    public static Settings getInstance() {
        if (instance == null ) {
           instance = new Settings();
        }

        return instance;
    }
}
