import numpy as np
import os
from PIL import Image
import glob
getFrom = "Mask"
pasteTo = "Ship8"

Cpath = str(os.getcwd()) + "/" + getFrom
print(Cpath)
png_files = list(glob.glob(Cpath + "/**/*.png", recursive = True))

for image in png_files:
    im = Image.open(image)
    data = np.array(im)

    p1, p2, p3 = 100, 100, 100

    r2, g2, b2 = data[:,:,0], data[:,:,1], data[:,:,2] # Value that we want to replace it with
    for k, w in zip(r2, range(len(r2))):
        for i, v in zip(r2[w], range(len(r2[w]))):
            r2[w][v] = i/100*p1

    for k, w in zip(g2, range(len(g2))):
        for i, v in zip(g2[w], range(len(g2[w]))):
            g2[w][v] = i/100*p2

    for k, w in zip(b2, range(len(b2))):
        for i, v in zip(b2[w], range(len(b2[w]))):
            b2[w][v] = i/100*p3

    data[:,:,0] = r2
    data[:,:,1] = g2
    data[:,:,2] = b2

    im = Image.fromarray(data)
    print(image.replace(str(os.path.basename(image)),"")[:-1].replace(getFrom, pasteTo))
    if not os.path.exists(image.replace(str(os.path.basename(image)),"")[:-1].replace(getFrom, pasteTo)):
        os.makedirs(image.replace(str(os.path.basename(image)),"")[:-1].replace(getFrom, pasteTo), exist_ok=True)

    im.save(f"{image.replace(getFrom, pasteTo)}")
